///home/berryj/link/bin/genMethods "-g" "-t" "UHyperGraph" "-r" "MUHyperGraph" "-I" "LINK/graph/UHyperGraph.h" "-y" "display_graph" "-w" "free_graph" "-d" "graph" "-f" "__uHyperGraph" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/graph/UHyperGraph.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>

void display_graph(SCM, SCM, int);
void free_graph(SCM);

typedef UHyperGraph _UHyperGraph;

#define _UHyperGraphDATA(x) ((UHyperGraph*) (EXTDATA(x)))
#define _UHyperGraphIS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<UHyperGraph >::type))
#define _UHyperGraphISNT_DATA(x) (!_UHyperGraphIS_DATA(x))

#define _UHyperGraphCXX_DATA(x) (*(UHyperGraph*) (EXTDATA(VAL(x))))
#define _UHyperGraphCXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<UHyperGraph >::type))
#define _UHyperGraphCXX_ISNT_DATA(x) (!_UHyperGraphCXX_IS_DATA(x))


PRIMITIVE STk_init___uHyperGraph()
{
	Wrapper<_UHyperGraph>::type = STk_new_CXXwrapper_id(
			Wrapper<_UHyperGraph>::name, 
			Wrapper<MUHyperGraph >::name,
			(void (*)(SCM x, SCM port, int mode))
			display_graph,
			(void (*)(SCM x))0,
			(void (*)(SCM x))free_graph);
	Tcl_InitHashTable(&Register<_UHyperGraph>::objTable, TCL_ONE_WORD_KEYS);
	return UNDEFINED;
}

void genExtra__uHyperGraphMethods(void);

PRIMITIVE STk_init_methods___uHyperGraph()
{
	genExtra__uHyperGraphMethods();
	return UNDEFINED;
}
